; zcat.el
; $Id: zcat.el,v 1.17 1996/09/07 18:32:29 sharl Exp $

set %%zcat-temp-file "/tmp/.zcat.temp"

store-procedure zcat-remove-temp-file
	silent-execute-program &cat "rm -f " %%zcat-temp-file
!endm

store-procedure zcat-read
	set %%ztemp &rea $cfname 0 2
	!if &and &equ &byt %%ztemp 0x1f &or &equ &byt &mid %%ztemp 2 1 0x8b &equ &byt &mid %%ztemp 2 1 0x9d
		set $cmode &bor $cmode 4096
		set %%zcat-orig-file $cfname
		print &cat "uncompressing gzipped file... " $cfname
		silent-execute-program &cat &cat &cat &cat "fish -fc 'gzip -cdf " &xla $cfname \ / ">" %%zcat-temp-file "'"
		!if $rval
			print "gzip deflation error"
			!goto rerror
		!endif
		set %%ztemp $readhook
		set $readhook ""
		read-file %%zcat-temp-file
		set $readhook %%ztemp
		set $cfname %%zcat-orig-file
*rerror
		zcat-remove-temp-file
		!return FALSE
	!endif
!endm

store-procedure zcat-insert
	set %%ztemp &rea $ifilename 0 2
	!if &and &equ &byt %%ztemp 0x1f &or &equ &byt &mid %%ztemp 2 1 0x8b &equ &byt &mid %%ztemp 2 1 0x9d
		set %%zcat-orig-file $ifilename
		print &cat "uncompressing gzipped file... " $ifilename
		silent-execute-program &cat &cat &cat &cat "fish -fc 'gzip -cdf " &xla $ifilename \ / ">" %%zcat-temp-file "'"
		!if $rval
			print "gzip deflation error"
			!goto ierror
		!endif
		set %%ztemp $ifilehook
		set $ifilehook ""
		insert-file %%zcat-temp-file
		set $ifilehook %%ztemp
*ierror
		zcat-remove-temp-file
		!return FALSE
	!endif
!endm

store-procedure zcat-write
	!if &ban $cmode 4096
		set %%zcat-orig-file $cfname
		set %%ztemp $writehook
		set $writehook ""
		write-file %%zcat-temp-file
		set $writehook %%ztemp
		print &cat "compressing file... " %%zcat-orig-file
		set $cfname %%zcat-orig-file
		silent-execute-program &cat &cat &cat &cat "fish -fc 'gzip -cn " %%zcat-temp-file ">" &xla $cfname \ / "'"
		!if $rval
			print "gzip inflation error"
		!endif
		print "compressing done."
		zcat-remove-temp-file
		!return FALSE
	!endif
!endm

set $readhook zcat-read
set $ifilehook zcat-insert
set $writehook zcat-write
